'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = AsyncBundleComp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _ramda = require('ramda');

var _asyncInjectors = require('./asyncInjectors');

var _asyncInjectors2 = _interopRequireDefault(_asyncInjectors);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const loadShape = (0, _propTypes.shape)({
    comp: (0, _propTypes.oneOfType)([(0, _propTypes.shape)({}), _propTypes.func]).isRequired,
    reducer: (0, _propTypes.oneOfType)([(0, _propTypes.shape)({}), _propTypes.func]),
    sagas: (0, _propTypes.oneOfType)([(0, _propTypes.shape)({}), _propTypes.func])
});

function AsyncBundleComp(store, createReducer) {
    var _class, _temp2;

    /* get async reducer and saga injectors */
    var _getAsyncInjectors = (0, _asyncInjectors2.default)(store, createReducer);

    const injectAsyncReducer = _getAsyncInjectors.injectAsyncReducer,
          injectAsyncSagas = _getAsyncInjectors.injectAsyncSagas;

    return _temp2 = _class = class AsyncBundle extends _react.PureComponent {
        constructor(...args) {
            var _temp;

            return _temp = super(...args), this.state = { mod: null }, this.elFromMod = mod => {
                /* return available render method */
                const Mod = (0, _utils.validImport)(mod);
                var _props = this.props;

                const children = _props.children,
                      load = _props.load,
                      rest = _objectWithoutProperties(_props, ['children', 'load']);

                return children ? children(Mod) : _react2.default.createElement(Mod, rest);
            }, this.load = props => {
                const name = props.name;
                var _props$load = props.load;
                const load = _props$load === undefined ? {} : _props$load;

                this.setState({ mod: null });

                /* Load all imports as Promises */
                const importModules = Promise.all([...(0, _utils.extractImports)(load)]);

                importModules.then(([mod, reducer, sagas]) => {
                    /* Inject reducer and sagas if they are available */
                    if (reducer) injectAsyncReducer(name, (0, _utils.validImport)(reducer));
                    if (sagas) injectAsyncSagas(name, (0, _utils.validImport)(sagas));

                    this.setState({ mod: this.elFromMod(mod) });
                });
            }, _temp;
        }

        componentWillMount() {
            this.load(this.props);
        }

        componentWillReceiveProps(nextProps) {
            if (!(0, _ramda.equals)(nextProps.load, this.props.load)) {
                this.load(nextProps);
            }
        }

        render() {
            return this.state.mod ? this.state.mod : null;
        }
    }, _class.propTypes = {
        load: (0, _propTypes.oneOfType)([_propTypes.array, (0, _propTypes.arrayOf)(loadShape), loadShape]).isRequired,
        name: _propTypes.string,
        children: (0, _propTypes.oneOfType)([(0, _propTypes.arrayOf)(_propTypes.node), _propTypes.node, _propTypes.func])
    }, _temp2;
}