'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = checkStore;

var _ramda = require('ramda');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _isType = require('./isType');

var _isType2 = _interopRequireDefault(_isType);

var _conformsTo = require('./conformsTo');

var _conformsTo2 = _interopRequireDefault(_conformsTo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Checks Redux store validity
 */
function checkStore(store) {
    store.asyncReducers = store.asyncReducers || {}; // eslint-disable-line no-param-reassign

    const shape = _extends({
        dispatch: (0, _isType2.default)('Function'),
        subscribe: (0, _isType2.default)('Function'),
        getState: (0, _isType2.default)('Function'),
        replaceReducer: (0, _isType2.default)('Function'),
        asyncReducers: (0, _isType2.default)('Object'),
        asyncSagas: store.asyncSagas ? (0, _isType2.default)('Object') : _ramda.isNil
    }, (0, _ramda.is)(Function, store.runSaga) ? { runSaga: (0, _isType2.default)('Function') } : {});

    (0, _invariant2.default)((0, _conformsTo2.default)(shape)(store), '(AsyncBundle/checkStore): Expected a valid Redux store');
}