'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

/**
 * Extracts imports from:
 * bundle-loader (https://github.com/webpack-contrib/bundle-loader)
 * babel-plugin-dynamic-import-node (https://github.com/airbnb/babel-plugin-dynamic-import-node)
 */
const importsFromFn = module => Reflect.ownKeys(module).includes('arguments') ? new Promise(module) : module();

/* returns array of imports from object */
const fromObject = (0, _ramda.props)(['comp', 'reducer', 'sagas']);
/* Loops imports to extract either a Module || Promise */
const getImports = (0, _ramda.map)((0, _ramda.when)((0, _ramda.is)(Function), importsFromFn));
/* extracts imports out of parameters */
const getModules = (0, _ramda.unless)((0, _ramda.is)(Array), fromObject);

/**
 * Extracts all async modules
 * @return {array}
 */
exports.default = (0, _ramda.compose)(getImports, getModules);